=== debian/changelog ===
ros-lunar-ompl (1.3.5-0stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mark Moll <mmoll@rice.edu>  Mon, 28 May 2018 22:10:06 -0000
